from sync_amz_data.tasks.account import AccountTask
from sync_amz_data.settings import LOG_CONF
from sync_amz_data.DataTransform import Data_ETL
from sync_amz_data.DataTransform.Data_ETL import Common_ETLMethod,SP_ETL,SB_ETL,SD_ETL
import logging.config
from apscheduler.schedulers.blocking import BlockingScheduler


logging.config.dictConfig(LOG_CONF)

if __name__ == '__main__':
    # AccountTask("3006125408623189").do({"record": "portfolios"})

    AWS_CREDENTIALS = {
        'lwa_client_id': 'amzn1.application-oa2-client.ebd701cd07854fb38c37ee49ec4ba109',
        'refresh_token': "Atzr|IwEBIL4ur8kbcwRyxVu_srprAAoTYzujnBvA6jU-0SMxkRgOhGjYJSUNGKvw24EQwJa1jG5RM76mQD2P22AKSq8qSD94LddoXGdKDO74eQVYl0RhuqOMFqdrEZpp1p4bIR6_N8VeSJDHr7UCuo8FiabkSHrkq7tsNvRP-yI-bnpQv4EayPBh7YwHVX3hYdRbhxaBvgJENgCuiEPb35Q2-Z6w6ujjiKUAK2VSbCFpENlEfcHNsjDeY7RCvFlwlCoHj1IeiNIaFTE9yXFu3aEWlExe3LzHv6PZyunEi88QJSXKSh56Um0e0eEg05rMv-VBM83cAqc5POmZnTP1vUdZO8fQv3NFLZ-xU6e1WQVxVPi5Cyqk4jYhGf1Y9t98N654y0tVvw74qNIsTrB-8bGS0Uhfe24oBEWmzObvBY3zhtT1d42myGUJv4pMTU6yPoS83zhPKm3LbUDEpBA1hvvc_09jHk7vUEAuFB-UAZzlht2C1yklzQ",
        'lwa_client_secret': 'cbf0514186db4df91e04a8905f0a91b605eae4201254ced879d8bb90df4b474d',
        'profile_id': "3006125408623189"
    }
    conn = Common_ETLMethod(**AWS_CREDENTIALS).clickhouse_connect()
    timezone = Common_ETLMethod(**AWS_CREDENTIALS).timeZone()
    print(timezone)

    sched = BlockingScheduler()
    sb_report = SB_ETL(**AWS_CREDENTIALS)
    sched.add_job(lambda: sb_report.reportV3_purchasedAsinRecord_ETL(conn),'cron',hour=6,minute=45,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_campaignsRecord_ETL(conn),'cron',hour=6,minute=50,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_campaignsVideo_ETL(conn),'cron',hour=6,minute=55,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_adGroupsRecord_ETL(conn),'cron',hour=7,minute=0,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_adGroupsVideo_ETL(conn),'cron',hour=7,minute=5,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_adsRecord_ETL(conn),'cron',hour=7,minute=10,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_adsVideo_ETL(conn),'cron',hour=7,minute=15,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_keywordsRecord_ETL(conn),'cron',hour=7,minute=20,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_keywordsVideo_ETL(conn),'cron',hour=7,minute=25,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_placementRecord_ETL(conn),'cron',hour=7,minute=30,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_placementVideo_ETL(conn),'cron',hour=7,minute=35,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_searchtermsRecord_ETL(conn),'cron',hour=7,minute=40,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_searchtermsVideo_ETL(conn),'cron',hour=7,minute=45,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_targetsRecord_ETL(conn),'cron',hour=7,minute=50,second=0,timezone=timezone)
    sched.add_job(lambda: sb_report.reportV2_targetsVideo_ETL(conn),'cron',hour=7,minute=55,second=0,timezone=timezone)

    sp_report = SP_ETL(**AWS_CREDENTIALS)
    sched.add_job(lambda: sp_report.reportV3_campaign_spCampaignsETL(conn),'cron',hour=8,minute=0,second=0,timezone=timezone)
    sched.add_job(lambda: sp_report.reportV3_adGroup_spCampaignsETL(conn),'cron',hour=8,minute=5,second=0,timezone=timezone)
    sched.add_job(lambda: sp_report.reportV3_campaignPlacement_spCampaignsETL(conn),'cron',hour=8,minute=10,second=0,timezone=timezone)
    sched.add_job(lambda: sp_report.reportV3_targeting_spTargetingETL(conn),'cron',hour=8,minute=15,second=0,timezone=timezone)
    sched.add_job(lambda: sp_report.reportV3_searchTerm_spSearchTermETL(conn),'cron',hour=8,minute=20,second=0,timezone=timezone)
    sched.add_job(lambda: sp_report.reportV3_advertiser_spAdvertisedProductETL(conn),'cron',hour=8,minute=25,second=0,timezone=timezone)
    sched.add_job(lambda: sp_report.reportV3_asin_spPurchasedProductETL(conn),'cron',hour=8,minute=30,second=0,timezone=timezone)

    sd_report = SD_ETL(**AWS_CREDENTIALS)
    sched.add_job(lambda: sd_report.reportV2_campaignsRecord_t2_ETL(conn),'cron',hour=8,minute=35,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_campaignsRecord_t3_ETL(conn),'cron',hour=8,minute=40,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_adGroupsRecord_t2_ETL(conn),'cron',hour=8,minute=45,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_adGroupsRecord_t3_ETL(conn),'cron',hour=8,minute=50,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_asins_t2_ETL(conn),'cron',hour=8,minute=55,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_asins_t3_ETL(conn),'cron',hour=9,minute=0,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_productAds_t2_ETL(conn),'cron',hour=9,minute=5,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_productAds_t3_ETL(conn),'cron',hour=9,minute=10,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_targets_t2_ETL(conn),'cron',hour=9,minute=15,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_productAds_t3_ETL(conn),'cron',hour=9,minute=20,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_campaign_matchedTarget_t2_ETL(conn),'cron',hour=9,minute=25,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_campaign_matchedTarget_t3_ETL(conn),'cron',hour=9,minute=30,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_adGroups_matchedTarget_t2_ETL(conn),'cron',hour=9,minute=35,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_adGroups_matchedTarget_t3_ETL(conn),'cron',hour=9,minute=40,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_targets_matchedTarget_t2_ETL(conn),'cron',hour=9,minute=45,second=0,timezone=timezone)
    sched.add_job(lambda: sd_report.reportV2_targets_matchedTarget_t3_ETL(conn),'cron',hour=9,minute=50,second=0,timezone=timezone)

    sched.start()
